SystemOrganization addCategory: #'Xtreams-Http'!

XTWriteStream subclass: #XTChunkingWriteStream
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 10:50'!
close
	self flush.
	destination
		put: $0;
		cr;
		lf;
		cr;
		lf.
	destination close. ! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 12:36'!
contentsSpecies
	^ destination contentsSpecies! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 22:18'!
flush
	destination write: (buffer activeSize printStringBase: 16).
	destination cr; lf.
	destination write: buffer.
	destination cr; lf.
	buffer clear.
	destination flush.
! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 10:31'!
on: aDestination
	super on: aDestination.
	buffer := XTBuffer on: (String new: 256).
	! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 10:28'!
write: anInteger from: aSequenceableCollection at: offset
	| size |
	size := anInteger min: buffer inactiveSize.
	buffer write: size from: aSequenceableCollection at: offset.
	size < anInteger ifTrue:
		[self flush.
		buffer write: (anInteger - size) from: aSequenceableCollection at: (offset + size)]
		! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 3/16/2011 00:43'!
chunking
	^ XTChunkingWriteStream on: self.! !
